package io.xjar.reflection;

import java.lang.reflect.Method;
import java.lang.reflect.Field;

public class XReflection
{
    public static XField field(Class<?> claxx, final String name) throws NoSuchFieldException {
        if (claxx == null) {
            throw new NullPointerException();
        }
        if (name == null) {
            throw new IllegalArgumentException("field name == null");
        }
        while (claxx != null) {
            try {
                final Field field = claxx.getDeclaredField(name);
                field.setAccessible(true);
                return new XField(field);
            }
            catch (final NoSuchFieldException e) {
                claxx = claxx.getSuperclass();
                continue;
            }
            break;
        }
        throw new NoSuchFieldException(name);
    }
    
    public static XMethod method(Class<?> claxx, final String name, final Class<?>... parameterTypes) throws NoSuchMethodException {
        if (claxx == null) {
            throw new NullPointerException();
        }
        if (name == null) {
            throw new IllegalArgumentException("method name == null");
        }
        while (claxx != null) {
            try {
                final Method method = claxx.getDeclaredMethod(name, parameterTypes);
                method.setAccessible(true);
                return new XMethod(method);
            }
            catch (final NoSuchMethodException e) {
                e.printStackTrace();
                claxx = claxx.getSuperclass();
                continue;
            }
            break;
        }
        throw new NoSuchMethodException(name);
    }
}
